"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = queueReducer;

var _ajv = require("ajv");

var _ajv2 = _interopRequireDefault(_ajv);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ajv = new _ajv2.default({ allErrors: true });

function queueReducer(state, action) {
  if (state.game.queue && state.game.queue.length > 0) {
    var schema = state.game.queue[0];
    var validate = ajv.compile(schema);
    var valid = validate(action);
    if (!valid) {
      throw new Error(JSON.stringify({ action: action, errors: validate.errors }, null, 2));
    }
  }
  if (state.game.nextActions) {
    return Object.assign({}, state, {
      game: Object.assign({}, state.game, {
        queue: state.game.nextActions.map(function (action) {
          return {
            type: "object",
            properties: {
              type: {
                type: "string",
                enum: [action.action.type]
              }
            }
          };
        })
      })
    });
  }

  return state;
}
//# sourceMappingURL=queue-reducer.js.map